<?php

$sRootPath = dirname(__FILE__);

while((strlen($sRootPath) > 2) && !is_dir($sRootPath . '/idealcheckout'))
{
	$sRootPath = dirname($sRootPath);
}

if(!is_dir($sRootPath . '/idealcheckout'))
{
	die('Cannot find /idealcheckout/ folder.<br>File: ' . __FILE__ . '<br>Line: ' . __LINE__);
}

require_once($sRootPath . '/idealcheckout/includes/library.php');



$nzshpcrt_gateways[$num]['name'] = 'Mastercard';
$nzshpcrt_gateways[$num]['display_name'] = 'Mastercard';
$nzshpcrt_gateways[$num]['api_version'] = 2.0;
$nzshpcrt_gateways[$num]['admin_name'] = 'iDEAL Checkout - Mastercard';
$nzshpcrt_gateways[$num]['internalname'] = 'idealcheckoutmastercard';
$nzshpcrt_gateways[$num]['class_name'] = 'wpsc_merchant_idealcheckoutmastercard';
$nzshpcrt_gateways[$num]['has_recurring_billing'] = false;
$nzshpcrt_gateways[$num]['wp_admin_cannot_cancel'] = true;
$nzshpcrt_gateways[$num]['form'] = 'form_idealcheckoutmastercard';
$nzshpcrt_gateways[$num]['submit_function'] = 'submit_idealcheckoutmastercard';

function form_idealcheckoutmastercard()
{
	return '';
}


class wpsc_merchant_idealcheckoutmastercard extends wpsc_merchant 
{
	var $name = '';

	function __construct($purchase_id = null, $is_receiving = false) 
	{
		$this->name = __('Mastercard', 'wpsc');
		parent::__construct($purchase_id, $is_receiving);
	}

	function submit()
	{
		global $wpdb;
		$this->set_purchase_processed_by_purchid(2);

		$aDatabaseSettings = idealcheckout_getDatabaseSettings();
		
		// Lookup last purchase
		$sql = "SELECT * FROM `" . $aDatabaseSettings['prefix'] . "wpsc_purchase_logs` WHERE (`sessionid` = '" . idealcheckout_escapeSql($this->cart_data['session_id']) . "') ORDER BY `id` DESC LIMIT 1";
		if($rsPurchase = idealcheckout_database_getRecord($sql))
		{
			$sStoreCode = idealcheckout_getStoreCode();
			$sGatewayCode = 'mastercard';
			$sLanguageCode = 'nl'; // nl, de, en
			$sCountryCode = '';
			$sCurrencyCode = 'EUR';

			$sOrderId = $rsPurchase['id'];
			$sOrderCode = idealcheckout_getRandomCode(32);
			$aOrderParams = array();
			$sTransactionId = idealcheckout_getRandomCode(32);
			$sTransactionCode = idealcheckout_getRandomCode(32);
			$fTransactionAmount = $rsPurchase['totalprice'];
			$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));
			
			$sTransactionUrl = $this->cart_data['transaction_results_url'];

			if(strpos($sTransactionUrl, '?') === false )
			{
				$sTransactionUrl .= '?sessionid=' . $this->cart_data['session_id'];
			}
			else
			{
				$sTransactionUrl .= '&sessionid=' . $this->cart_data['session_id'];
			}
			
			$sTransactionSuccessUrl = $sTransactionUrl;
			$sTransactionPendingUrl = $sTransactionUrl;
			$sTransactionFailureUrl = $sTransactionUrl;




			$sql = "SELECT `" . $aDatabaseSettings['prefix'] . "wpsc_checkout_forms`.`unique_name` AS `key`, `" . $aDatabaseSettings['prefix'] . "wpsc_submited_form_data`.`value` FROM `" . $aDatabaseSettings['prefix'] . "wpsc_submited_form_data` LEFT JOIN `" . $aDatabaseSettings['prefix'] . "wpsc_checkout_forms` ON `" . $aDatabaseSettings['prefix'] . "wpsc_submited_form_data`.`form_id` = `" . $aDatabaseSettings['prefix'] . "wpsc_checkout_forms`.`id` WHERE (`" . $aDatabaseSettings['prefix'] . "wpsc_submited_form_data`.`log_id` = '" . $rsPurchase['id'] . "') AND (NOT `value` IS NULL) AND (NOT `value` = '') ORDER BY `key`;";
			$aFormData = idealcheckout_database_getRecords($sql);


			$aOrderParams['purchase_id'] = $rsPurchase['id'];
			$aOrderParams['session_id'] = $this->cart_data['session_id'];
			$aOrderParams['customer'] = array();

			// Shipment data
			list($sStreetName, $sStreetNumber, $sExtension) = idealcheckout_mb_splitAddress(idealcheckout_getFormValue($aFormData, 'shipping', 'address'));

			$aOrderParams['customer']['shipment_company'] = '';
			$aOrderParams['customer']['shipment_name'] = idealcheckout_getFormValue($aFormData, 'shipping', 'firstname') . ' ' . idealcheckout_getFormValue($aFormData, 'shipping', 'lastname');
			$aOrderParams['customer']['shipment_first_name'] = idealcheckout_getFormValue($aFormData, 'shipping', 'firstname');
			$aOrderParams['customer']['shipment_last_name'] = idealcheckout_getFormValue($aFormData, 'shipping', 'lastname');
			$aOrderParams['customer']['shipment_gender'] = '';
			$aOrderParams['customer']['shipment_date_of_birth'] = '';
			$aOrderParams['customer']['shipment_phone'] = idealcheckout_getFormValue($aFormData, 'shipping', 'phone');
			$aOrderParams['customer']['shipment_email'] = idealcheckout_getFormValue($aFormData, 'shipping', 'email');
			$aOrderParams['customer']['shipment_address'] = idealcheckout_getFormValue($aFormData, 'shipping', 'address');
			$aOrderParams['customer']['shipment_street_name'] = $sStreetName;
			$aOrderParams['customer']['shipment_street_number'] = $sStreetNumber;
			$aOrderParams['customer']['shipment_street_number_extension'] = $sExtension;
			$aOrderParams['customer']['shipment_zipcode'] = idealcheckout_getFormValue($aFormData, 'shipping', 'postcode');
			$aOrderParams['customer']['shipment_city'] = idealcheckout_getFormValue($aFormData, 'shipping', 'city');
			$aOrderParams['customer']['shipment_country_code'] = idealcheckout_getFormValue($aFormData, 'shipping', 'country');
			$aOrderParams['customer']['shipment_country_name'] = ((strcasecmp($aOrderParams['customer']['shipment_country_code'], 'BE') === 0) ? 'Belgie' : 'Nederland');


			// Payment data
			list($sStreetName, $sStreetNumber, $sExtension) = idealcheckout_mb_splitAddress(idealcheckout_getFormValue($aFormData, 'billing', 'address'));

			$aOrderParams['customer']['payment_company'] = '';
			$aOrderParams['customer']['payment_name'] = idealcheckout_getFormValue($aFormData, 'billing', 'firstname') . ' ' . idealcheckout_getFormValue($aFormData, 'billing', 'lastname');
			$aOrderParams['customer']['payment_first_name'] = idealcheckout_getFormValue($aFormData, 'billing', 'firstname');
			$aOrderParams['customer']['payment_last_name'] = idealcheckout_getFormValue($aFormData, 'billing', 'lastname');
			$aOrderParams['customer']['payment_gender'] = '';
			$aOrderParams['customer']['payment_date_of_birth'] = '';
			$aOrderParams['customer']['payment_phone'] = idealcheckout_getFormValue($aFormData, 'billing', 'phone');
			$aOrderParams['customer']['payment_email'] = idealcheckout_getFormValue($aFormData, 'billing', 'email');
			$aOrderParams['customer']['payment_address'] = idealcheckout_getFormValue($aFormData, 'billing', 'address');
			$aOrderParams['customer']['payment_street_name'] = $sStreetName;
			$aOrderParams['customer']['payment_street_number'] = $sStreetNumber;
			$aOrderParams['customer']['payment_street_number_extension'] = $sExtension;
			$aOrderParams['customer']['payment_zipcode'] = idealcheckout_getFormValue($aFormData, 'billing', 'postcode');
			$aOrderParams['customer']['payment_city'] = idealcheckout_getFormValue($aFormData, 'billing', 'city');
			$aOrderParams['customer']['payment_country_code'] = idealcheckout_getFormValue($aFormData, 'billing', 'country');
			$aOrderParams['customer']['payment_country_name'] = ((strcasecmp($aOrderParams['customer']['payment_country_code'], 'BE') === 0) ? 'Belgie' : 'Nederland');




			// Products
			$sql = "SELECT * FROM `" . $aDatabaseSettings['prefix'] . "wpsc_cart_contents` WHERE (`purchaseid` = '" . $rsPurchase['id'] . "') ORDER BY `id` ASC;";
			$aProducts = idealcheckout_database_getRecords($sql);


			$aOrderParams['products'] = array();

			$fTotalAmountIncl = 0.00;
			$fTotalAmountExcl = 0.00;
			$fProductShipment = 0.00;

			foreach($aProducts as $k => $aProduct)
			{
				if(floatval($rsPurchase['wpec_taxes_rate']) > 0) // Price EXCL vat
				{
					$fPriceExcl = round($aProduct['price'], 2);
					$fPriceVat = round(($aProduct['price'] * $rsPurchase['wpec_taxes_rate']) / 100, 2);
					$fPriceIncl = round($fPriceExcl + $fPriceVat, 2);

					$fVatPercentage = round($rsPurchase['wpec_taxes_rate'], 2);
					$fQuantity = $aProduct['quantity'];
				}
				else // Price INCL vat
				{
					$fPriceIncl = round($aProduct['price'], 2);
					$fPriceVat = round($aProduct['tax_charged'] / $aProduct['quantity'], 2);
					$fPriceExcl = round($fPriceIncl - $fPriceVat, 2);

					$fVatPercentage = round($aProduct['gst'], 2);
					$fQuantity = $aProduct['quantity'];
				}

				$fTotalAmountIncl += ($fPriceIncl * $fQuantity);
				$fTotalAmountExcl += ($fPriceExcl * $fQuantity);
				$fProductShipment += round($aProduct['pnp'], 2);

				$aOrderParams['products'][] = array('code' => $aProduct['prodid'], 'description' => $aProduct['name'], 'quantity' => $fQuantity, 'price_incl' => $fPriceIncl, 'price_excl' => $fPriceExcl, 'vat' => $fVatPercentage);
			}


/*
			// Payment costs?
			$fPaymentExcl = round(empty($order->info['payment_cost']) ? 0 : ($order->info['payment_cost'] * $order->info['currency_value']), 2);
			$fPaymentTaxPercentage = round(empty($order->info['payment_tax']) ? 0 : $order->info['payment_tax'], 2);
			$fPaymentTax = round($fPaymentExcl * ($fPaymentTaxPercentage / 100), 2);
			$fPaymentIncl = round($fPaymentExcl + $fPaymentTax, 2);

			if(!empty($fPaymentIncl))
			{
				$fTotalAmountIncl += $fPaymentIncl;
				$fTotalAmountExcl += $fPaymentExcl;

				$aOrderParams['products'][] = array('code' => 'PAYMENT', 'description' => 'Betaalkosten', 'quantity' => '1', 'price_incl' => $fPaymentIncl, 'price_excl' => $fPaymentExcl, 'vat' => $fPaymentTaxPercentage);
			}
*/


			// Shipment costs?
			if(empty($rsPurchase['wpec_taxes_rate']))
			{
				$fShipmentExcl = round((empty($rsPurchase['base_shipping']) ? 0 : $rsPurchase['base_shipping']) + $fProductShipment, 2);
				$fShipmentTaxPercentage = round(empty($rsPurchase['wpec_taxes_rate']) ? 0 : $rsPurchase['wpec_taxes_rate'], 2);
				$fShipmentTax = round($fShipmentExcl * ($fShipmentTaxPercentage / 100), 2);
				$fShipmentIncl = round($fShipmentExcl + $fShipmentTax, 2);
			}
			else
			{
				$fShipmentExcl = round((empty($rsPurchase['base_shipping']) ? 0 : $rsPurchase['base_shipping']) + $fProductShipment, 2);
				$fShipmentTaxPercentage = round(0, 2);
				$fShipmentTax = round($fShipmentExcl * ($fShipmentTaxPercentage / 100), 2);
				$fShipmentIncl = round($fShipmentExcl + $fShipmentTax, 2);
			}

			if(!empty($fShipmentIncl))
			{
				$fTotalAmountIncl += $fShipmentIncl;
				$fTotalAmountExcl += $fShipmentExcl;

				$aOrderParams['products'][] = array('code' => 'SHIPPING', 'description' => 'Verzendkosten', 'quantity' => '1', 'price_incl' => $fShipmentIncl, 'price_excl' => $fShipmentExcl, 'vat' => $fShipmentTaxPercentage);
			}

			$fCorrection = round($fTransactionAmount - $fTotalAmountIncl, 2);

			if($fCorrection != 0.00)
			{
				$aOrderParams['products'][] = array('code' => 'CORRECTION', 'description' => 'Correctie', 'quantity' => '1', 'price_incl' => $fCorrection, 'price_excl' => $fCorrection, 'vat' => 0);
			}




			// Insert into #_transactions
			$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";

			idealcheckout_database_query($sql);

			header("Location: " . idealcheckout_getRootUrl() . 'idealcheckout/setup.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode);
			exit;
		}
		else
		{
			print('ERROR: No purchases available for session "' . $this->cart_data['session_id'] . '".');
			print("\n\n<!--\n\nFILE: " . __FILE__ . "\nLINE: " . __LINE__ . "\n\n-->\n\n");
			exit;
		}
	}

	// wpsc_action=gateway_notification&gateway=idealcheckoutmastercard
	function process_gateway_notification()
	{
		global $wpdb;

		if(!empty($_GET['transaction_id']) && !empty($_GET['transaction_code']))
		{
			$aDatabaseSettings = idealcheckout_getDatabaseSettings();

			$sTransactionId = $_GET['transaction_id'];
			$sTransactionCode = $_GET['transaction_code'];

			$sql = "SELECT * FROM `" . $aDatabaseSettings['table'] . "` WHERE (`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "') AND (`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "');";
			if($aRecord = idealcheckout_database_getRecord($sql))
			{
				$aOrderParams = idealcheckout_unserialize($aRecord['order_params']);

				$iOrderStatusId = 1;

				if(in_array($aRecord['transaction_status'], array('', 'OPEN', 'PENDING'))) // Pending
				{
					$iOrderStatusId = 2;
				}
				elseif(in_array($aRecord['transaction_status'], array('SUCCESS'))) // Success
				{
					$iOrderStatusId = 3;
				}
				elseif(in_array($aRecord['transaction_status'], array('CANCELLED', 'FAILED', 'EXPIRED'))) // Cancelled
				{
					$iOrderStatusId = 6;
				}

				if($iOrderStatusId > 1)
				{
					$sql = "SELECT * FROM `" . $aDatabaseSettings['prefix'] . "wpsc_purchase_logs` WHERE (`processed` = '" . $iOrderStatusId . "') AND `id` = '" . idealcheckout_escapeSql($aRecord['order_id']) . "' LIMIT 1;";
					if(idealcheckout_database_getRecord($sql))
					{
						// Already processed
					}
					else
					{
						// $this->set_transaction_details($sTransactionId, $iOrderStatusId);
						wpsc_update_purchase_log_details($aOrderParams['purchase_id'], array('processed' => $iOrderStatusId, 'transactid' => $sTransactionId));

						if(in_array($iOrderStatusId, array(2, 3)))
						{
							transaction_results($aOrderParams['session_id'], false);
						}
					}
				}

				// die('GATEWAY NOTIFICATION PROCESSED, STATUS: ' . $iOrderStatusId . ', TRANSACTION: ' . $sTransactionId);
				die('GATEWAY NOTIFICATION PROCESSED');
			}
		}

		die('GATEWAY NOTIFICATION FAILURE');
	}






	// Display admin panel for iDEAL configuration
	function idealcheckoutmastercard_admin_panel()
	{
		$aGatewaySettings = idealcheckout_getGatewaySettings(false, 'mastercard');
	
		$sHtml = '
<p>Via deze plugin kunt u Mastercard betalingen ontvangen in uw webshop via diverse Payment Service Providers.</p>
<p>Deze plugin is momenteel geconfigureerd om Mastercard transacties te verwerken via <b>' . htmlspecialchars($aGatewaySettings['GATEWAY_NAME']) . '</b>.<br>Meer informatie over deze Payment Service Provider vind u op <a href="' . htmlspecialchars($aGatewaySettings['GATEWAY_WEBSITE']) . '" target="_blank">' . htmlspecialchars($aGatewaySettings['GATEWAY_WEBSITE']) . '</a></p>';

		if($aGatewaySettings['GATEWAY_VALIDATION'])
		{
			$sHtml .= '
<h2>Transacties Controleren</h2>
<p>Controleer de status van alle openstaande transacties bij uw Payment Service Provider.</p>
<p><input type="button" value="Controleer openstaande transacties." onclick="javascript: window.open(\'' . idealcheckout_getRootUrl(1) . 'idealcheckout/validate.php?gateway=mastercard\', \'popup\', \'directories=no,height=550,location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,toolbar=no,width=750\');"></p>';
		}

		$sHtml .= '
<h2>Over deze plugin</h2>
<p>Deze Mastercard plugin is ontwikkeld door <a href="https://www.ideal-checkout.nl" target="_blank">iDEAL Checkout</a> en is GRATIS te downloaden via <a href="http://www.ideal-checkout.nl" target="_blank">http://www.ideal-checkout.nl</a>.<br><br>- Voor vragen over deze plugin kunt u kijken op <a href="http://www.ideal-checkout.nl" target="_blank">http://www.ideal-checkout.nl</a> of mailen naar <a href="mailto:info@ideal-checkout.nl">info@ideal-checkout.nl</a><br>- Feedback en donaties<br>- Het gebruik van onze plugins/scripts is geheel op eigen risico.</p>';

		return $sHtml;
	}

	function idealcheckoutmastercard_admin_submit()
	{
		return true;
	}
}

	if(!function_exists('idealcheckout_getFormValue'))
	{
		function idealcheckout_getFormValue($aFormData, $sSection, $sName)
		{
			foreach($aFormData as $aFormField)
			{
				if(strcmp($aFormField['key'], $sSection . $sName) === 0)
				{
					return $aFormField['value'];
				}
			}

			$sSection = ((strcmp($sSection, 'shipping') === 0) ? 'billing' : 'shipping');

			foreach($aFormData as $aFormField)
			{
				if(strcmp($aFormField['key'], $sSection . $sName) === 0)
				{
					return $aFormField['value'];
				}
			}

			return '';
		}
	}

?>